package org.exoplatform.portlets.content.actions.component;

import java.util.Iterator;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIToolbar;
import org.exoplatform.faces.core.component.model.Button;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.admin.component.UIECMAdminSummary;
import org.exoplatform.services.cms.actions.ActionServiceContainer;


public class UIActionTypeList extends UIExoCommand{
  
  final static public String ADD_ACTION = "add".intern();  
  
  public static Parameter[] ADD_PARAMS = { new Parameter(ACTION , ADD_ACTION)} ;
  public static Parameter[] CANCEL_PARAMS = { new Parameter(ACTION , CANCEL_ACTION)} ;  

  private boolean hasActions;

  private ActionServiceContainer actionsServiceContainer_;
  
  public UIActionTypeList(ActionServiceContainer actionsServiceContainer) {
    setId("UIRuleTypeList") ;
    setRendererType("VelocityRenderer") ;
        
    actionsServiceContainer_ = actionsServiceContainer;
    
    UIToolbar toolbar = new UIToolbar("MainToolbar"); 
    getChildren().add(toolbar);
    toolbar.addLeftButton(new Button("#{UIActionTypeList.button.add}", ADD_PARAMS));    
    toolbar.addRightButton(new Button("#{UIActionTypeList.button.cancel}", CANCEL_PARAMS));
    
    addActionListener(AddActionListener.class, ADD_ACTION) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }

  public boolean hasActions() throws Exception{
     return !actionsServiceContainer_.getCreatedActionTypes().isEmpty();
  }
  
  public Iterator getActions() throws Exception{
    return actionsServiceContainer_.getCreatedActionTypes().iterator();
  }

  static public class AddActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIActionTypeList uicomp = (UIActionTypeList) event.getComponent() ;
      UIActionTypeFormController actionTypeFormController = (UIActionTypeFormController) uicomp.getSibling(
          UIActionTypeFormController.class);
      actionTypeFormController.showNewActionTypeForm();
      uicomp.setRenderedSibling(UIActionTypeFormController.class);
    }
  }    
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIActionTypeList uicomp = (UIActionTypeList) event.getComponent() ;
      uicomp.setRenderedSibling(UIECMAdminSummary.class);
    }
  }    
  
}