package org.exoplatform.portlets.content.actions.component;

import javax.jcr.Node;

import org.exoplatform.faces.cms.CMSDelegate;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.cms.actions.ActionServiceContainer;
import org.exoplatform.services.grammar.wiki.WikiContext;
import org.exoplatform.services.grammar.wiki.WikiEngineService;

public class UIActionView extends UISimpleForm{
  
  private CMSDelegate delegate;
  private ActionServiceContainer container_;
  
  public UIActionView(ActionServiceContainer container) {
    super("UIActionView", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer");    
    
    container_ = container;
    
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
  }

  public void editMove(Node node, String name) throws Exception {
    Node anode = container_.getAction(node, name);
    delegate = new CMSDelegate(anode);    
  }  
  
  public Node getNode() throws Exception{
    return delegate.getNode();
  }
  
  public void setNode(Node node){
    delegate.setNode(node);
  }  
  
  public String getPortalName() {
    return delegate.getPortalName();
  }
  
  public String getWorkspaceName() throws Exception {
    return delegate.getWorkspaceName();
  }  
  
  public boolean isNodeTypeSupported() {
    return delegate.isNodeTypeSupported();
  }  
  
  public WikiContext getWikiContext() {
    return delegate.getWikiContext();
  }
  
  public WikiEngineService getWikiService() {
    return delegate.getWikiService();
  }    

  public String getNodeType() throws Exception {
    return delegate.getNodeType();
  }
  
  public String getTemplatePath() throws Exception {
    return delegate.getTemplatePath();
  }

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIActionView uicomp = (UIActionView) event.getSource();
      ((UIExoComponent)uicomp.getParent()).setRenderedSibling(UIActionList.class);      
    }
  }    
  
}
