package org.exoplatform.portlets.content.jcr;

import java.util.ResourceBundle;

import javax.jcr.AccessDeniedException;
import javax.jcr.InvalidItemStateException;
import javax.jcr.InvalidSerializedDataException;
import javax.jcr.ItemExistsException;
import javax.jcr.ItemNotFoundException;
import javax.jcr.LoginException;
import javax.jcr.NoSuchWorkspaceException;
import javax.jcr.PathNotFoundException;
import javax.jcr.ReferentialIntegrityException;
import javax.jcr.RepositoryException;
import javax.jcr.ValueFormatException;
import javax.jcr.lock.LockException;
import javax.jcr.nodetype.ConstraintViolationException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.version.VersionException;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.Util;
import org.exoplatform.portal.Information;

public class JCRExceptionManager {

  public static void process(Information iprovider, Exception e) throws Exception{    
    ResourceBundle res =  Util.getApplicationResourceBundle()  ;
    if(e instanceof LoginException) {
      iprovider.addMessage(new ExoFacesMessage(res.getString("LoginException.msg"))) ;
    } else if(e instanceof AccessDeniedException) {
      iprovider.addMessage(new ExoFacesMessage(res.getString("AccessDeniedException.msg"))) ;
    } else if(e instanceof NoSuchWorkspaceException) {
      iprovider.addMessage(new ExoFacesMessage(res.getString("NoSuchWorkspaceException.msg"))) ;
    } else if(e instanceof ItemNotFoundException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("ItemNotFoundException.msg"))) ;
    } else if(e instanceof ItemExistsException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("ItemExistsException.msg"))) ;
    } else if(e instanceof ConstraintViolationException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("ConstraintViolationException.msg"))) ;
    } else if(e instanceof InvalidItemStateException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("InvalidItemStateException.msg"))) ;
    } else if(e instanceof ReferentialIntegrityException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("ReferentialIntegrityException.msg"))) ;
    } else if(e instanceof LockException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("LockException.msg"))) ;
    } else if(e instanceof NoSuchNodeTypeException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("NoSuchNodeTypeException.msg"))) ;
    } else if(e instanceof VersionException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("VersionException.msg"))) ;
    } else if(e instanceof PathNotFoundException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("PathNotFoundException.msg"))) ;
    } else if(e instanceof ValueFormatException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("ValueFormatException.msg"))) ;
    } else if(e instanceof InvalidSerializedDataException) { 
      iprovider.addMessage(new ExoFacesMessage(res.getString("InvalidSerializedDataException.msg"))) ;
    } else if(e instanceof RepositoryException) {
      iprovider.addMessage(new ExoFacesMessage(res.getString("RepositoryException.msg"))) ;
    } else {
      throw e;
    }
  }

}
