package org.exoplatform.portlets.content.jcr.component;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.exoplatform.faces.core.component.InformationProvider;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.component.UIViewController.CancelActionListener;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;

public class UIFolderForm extends UISimpleForm implements ChangeNodeListener {

  final static public String INPUT_NAME = "name";
  protected Node node_;

  public UIFolderForm() throws Exception {
    super("folderForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");

    add(new UIStringInput("name", ""));

    addActionListener(AddFolderActionListener.class, SAVE_ACTION);
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
  }

  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    setRendered(false);
    node_ = node;
  }

  public Node getNode() {
    return node_;
  }

  static public class AddFolderActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIFolderForm uicomp = (UIFolderForm) event.getSource();
      UIJCRExplorer uiExplorer = (UIJCRExplorer) uicomp.getAncestorOfType(UIJCRExplorer.class);
      String name = uicomp.getUIInput(INPUT_NAME).getValue();
      Information iprovider = findInformationProvider(uicomp);
      try {
        Node node = uiExplorer.getSelectNode();
        node.addNode(name, "nt:folder");
        uiExplorer.broadcastOnChange(node);
      } catch (Exception e) {
        JCRExceptionManager.process(iprovider, e);
      }

    }
  }  
}
