/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr.component;

import java.util.ArrayList;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.NodeIterator;

import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.cms.templates.TemplateService;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentDisplayer.java,v 1.2 2004/08/07 18:11:26 tuan08 Exp $
 */
public class UISelectDocumentForm extends UISimpleForm  {
 
  final static public String CHANGE_DOCUMENT_ACTION = "changeDocument" ;
  
  UISelectBox uiSelect_ ;
  
  private String defaultDocument_;

  private TemplateService templateService_;
  
  public UISelectDocumentForm(TemplateService templateService) throws Exception {
    super("selectDocumentForm", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer");
    
    uiSelect_ = new  UISelectBox("documentType", "", null) ;
    uiSelect_.setUpdateOnChangeAction(CHANGE_DOCUMENT_ACTION) ;
    add(uiSelect_) ;
    
    templateService_ = templateService;
    
    addActionListener(ChangeDocumentActionListener.class, CHANGE_DOCUMENT_ACTION) ;
  }  
  
  private NodeIterator getDocumentTypes() throws Exception{
    return templateService_.getDocumentTypes();
  }
  
  public String getDefaultDocument() throws Exception{    
    if(defaultDocument_ == null) {
      NodeIterator documentTypes = getDocumentTypes();
      defaultDocument_ = documentTypes.nextNode().getName();      
    }
    return defaultDocument_;
  }  
  
  public void update() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    NodeIterator documentTypes = getDocumentTypes();    
    while(documentTypes.hasNext()){
      Node node = documentTypes.nextNode();
      options.add(new SelectItem(node.getName(), node.getName()));
    }    
    uiSelect_.setOptions(options) ;
    uiSelect_.setValue(getDefaultDocument());
  }
  
  static public class ChangeDocumentActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UISelectDocumentForm uicomp = (UISelectDocumentForm) event.getSource() ;
      String document = uicomp.uiSelect_.getValue() ;
      UIDocumentForm uiForm = (UIDocumentForm) uicomp.getSibling(UIDocumentForm.class) ;
      uiForm.showNewDocument(document) ;
    }
  }

}