package org.exoplatform.services.cms.actions;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

public class ScriptActionType extends NodeTypeImpl{
  
  public ScriptActionType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:scriptAction";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("exo:action");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[1];
        
    this.declaredPropertyDefinitions[0] = 
        new PropertyDefinitionImpl("exo:script",         //name
                            this,                        //declaringNodeType
                            PropertyType.STRING,         //requiredType
                            null,                        //valueConstraints 
                            NULL_VALUES,                        //defaultValues
                            false,                       //autoCreate       
                            true,                        //mandatory        
                            OnParentVersionAction.IGNORE,//onVersion        
                            false,                       //readOnly         
                            false                        //multiple         
        );
    
    this.declaredChildNodeDefinitions = new NodeDefinition[0];
  }
}

