#!/bin/sh
# -----------------------------------------------------------------------------
# Start Script for the CATALINA Server
#
# $Id: startup.sh,v 1.4 2004/11/17 20:17:46 yoavs Exp $
# -----------------------------------------------------------------------------
#####################################################################################
#                      EXO CONFIGURATION                                            #
#####################################################################################
LOG_OPTS="-Dorg.apache.commons.logging.Log=org.apache.commons.logging.impl.SimpleLog"
SECURITY_OPTS="-Djava.security.auth.login.config=../conf/jaas.conf"

#AGENT_OPTS="-javaagent:$CATALINA_HOME/common/lib/aspectwerkz-jdk5-2.0.jar"
#XBOOT_PATH="$CATALINA_HOME/common/lib/aspectwerkz-2.0.jar:$CATALINA_HOME/common/lib/aspectwerkz-core-2.0.jar:$CATALINA_HOME/common/lib/aspectwerkz-jdk5-2.0.jar:$CATALINA_HOME/common/lib/trove-1.0.2.jar:$CATALINA_HOME/common/lib/jrexx-1.1.1.jar:$CATALINA_HOME/common/lib/dom4j-1.4.jar"

#if $cygwin; then
#  XBOOT_PATH=`cygpath --path --windows "$XBOOT_PATH"`
#fi
#XBOOT_OPTS="-Xbootclasspath/p:$XBOOT_PATH"
#CATALINA_OPTS="$AGENT_OPTS $XBOOT_OPTS $LOG_OPTS $SECURITY_OPTS $CATALINA_OPT"

JAVA_OPTS="$LOG_OPTS $SECURITY_OPTS $JAVA_OPTS"
#####################################################################################
#                     END  EXO CONFIGURATION                                        #
#####################################################################################

# Better OS/400 detection: see Bugzilla 31132
os400=false
case "`uname`" in
CYGWIN*) cygwin=true;;
OS400*) os400=true;;
esac

# resolve links - $0 may be a softlink
PRG="$0"

while [ -h "$PRG" ] ; do
  ls=`ls -ld "$PRG"`
  link=`expr "$ls" : '.*-> \(.*\)$'`
  if expr "$link" : '.*/.*' > /dev/null; then
    PRG="$link"
  else
    PRG=`dirname "$PRG"`/"$link"
  fi
done
 
PRGDIR=`dirname "$PRG"`
EXECUTABLE=catalina.sh

# Check that target executable exists
if $os400; then
  # -x will Only work on the os400 if the files are: 
  # 1. owned by the user
  # 2. owned by the PRIMARY group of the user
  # this will not work if the user belongs in secondary groups
  eval
else
  if [ ! -x "$PRGDIR"/"$EXECUTABLE" ]; then
    echo "Cannot find $PRGDIR/$EXECUTABLE"
    echo "This file is needed to run this program"
    exit 1
  fi
fi 

exec "$PRGDIR"/"$EXECUTABLE" run "$@"
