/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.nodetype.*;
import javax.jcr.PropertyType;
import javax.jcr.version.OnParentVersionAction;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import javax.jcr.RepositoryException;
import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;


/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 31 juil. 2004
 */
public class FrozenNodeType extends NodeTypeImpl {

  public FrozenNodeType(NodeTypeManager manager) throws NoSuchNodeTypeException,RepositoryException {

    super(manager);
    this.name = "nt:frozenNode";
    this.mixin = false;
    this.orderableChild = true;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[2];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredSupertypes[1] = manager.getNodeType("mix:referenceable");
    this.declaredPropertyDefinitions = new PropertyDefinitionImpl[5];
    this.declaredChildNodeDefinitions = new NodeDefinition[1];

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "jcr:frozenPrimaryType",           //name
        this,                         //declaringNodeType
        PropertyType.NAME,          //requiredType
        EMPTY_CONSTRAINTS,            //valueConstraints 
        null,                         //defaultValues
        true,                         //autoCreate
        true,                         //mandatory        
        OnParentVersionAction.ABORT,   //onVersion
        true,                        //readOnly
        false                         //multiple         
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "jcr:frozenMixinTypes",             //name
        this,                         //declaringNodeType
        PropertyType.NAME,            //requiredType
        EMPTY_CONSTRAINTS,            //valueConstraints 
        null,                         //defaultValues
        false,                         //autoCreate
        false,                        //mandatory
        OnParentVersionAction.ABORT,   //onVersion
        true,                        //readOnly
        true                          //multiple         
        );

    this.declaredPropertyDefinitions[2] = new PropertyDefinitionImpl(
        "jcr:frozenUuid",                //name
        this,                         //declaringNodeType
        PropertyType.STRING,         //requiredType
        EMPTY_CONSTRAINTS,           //valueConstraints 
        null,                         //defaultValues
        true,                         //autoCreate
        true ,                        //mandatory
        OnParentVersionAction.ABORT,   //onVersion
        true,                        //readOnly
        false                          //multiple
        );

    this.declaredPropertyDefinitions[3] = new PropertyDefinitionImpl(
        ItemDefinitionImpl.RESIDUAL_SET, //name
        this,                         //declaringNodeType
        PropertyType.UNDEFINED,         //requiredType
        EMPTY_CONSTRAINTS,             //valueConstraints 
        null,                          //defaultValues
        false,                         //autoCreate
        false ,                        //mandatory
        OnParentVersionAction.ABORT,   //onVersion
        true,                        //readOnly
        false                          //multiple
        );

    this.declaredPropertyDefinitions[4] = new PropertyDefinitionImpl(
        ItemDefinitionImpl.RESIDUAL_SET,         //name
        this,                         //declaringNodeType
        PropertyType.UNDEFINED,            //requiredType
        EMPTY_CONSTRAINTS,            //valueConstraints 
        null,                         //defaultValues
        false,                         //autoCreate
        false,                        //mandatory
        OnParentVersionAction.ABORT,   //onVersion
        true,                        //readOnly
        true                          //multiple
        );


    NodeType[] types = {manager.getNodeType("nt:base")};

    this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
        ItemDefinitionImpl.RESIDUAL_SET,         // name
        this,                             // declaringNodeType
        types,                            // requiredNodeTypes
        null,                             // defaultNodeType  
        false,                            // autoCreate       
        false,                            // mandatory        
        OnParentVersionAction.ABORT,    // onVersion        
        true,                            // protected
        true                             // same-name sibling
        );
  }
}
