/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeDefinition;


import javax.jcr.version.OnParentVersionAction;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.mix.ReferenceableType;
import javax.jcr.nodetype.PropertyDefinition;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import javax.jcr.PropertyType;
import javax.jcr.Value;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.RepositoryException;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: ResourceType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class ResourceType extends NodeTypeImpl {

  public ResourceType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "nt:resource";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = "jcr:data";
    this.declaredSupertypes = new NodeType[2];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredSupertypes[1] = manager.getNodeType("mix:referenceable");
    this.declaredPropertyDefinitions = new PropertyDefinition[4];

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "jcr:encoding",                  //name
        this,                            //declaringNodeType
        PropertyType.STRING,             //requiredType     
        EMPTY_CONSTRAINTS,               //valueConstraints 
        null,                            //defaultValues
        false,                           //autoCreate       
        false,                           //mandatory        
        OnParentVersionAction.COPY,      //onVersion        
        false,                           //readOnly         
        false                            //multiple         
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "jcr:mimeType",                  //name
        this,                            //declaringNodeType
        PropertyType.STRING,             //requiredType     
        EMPTY_CONSTRAINTS,                //valueConstraints 
        null,                            //defaultValues
        false,                           //autoCreate       
        true,                            //mandatory        
        OnParentVersionAction.COPY,      //onVersion        
        false,                           //readOnly         
        false                            //multiple         
        );

    this.declaredPropertyDefinitions[2] = new PropertyDefinitionImpl(
        "jcr:data",                      //name
        this,                            //declaringNodeType
        PropertyType.BINARY,             //requiredType     
        EMPTY_CONSTRAINTS,               //valueConstraints 
        null,                            //defaultValues
        false,                           //autoCreate       
        true,                            //mandatory        
        OnParentVersionAction.COPY,      //onVersion        
        false,                           //readOnly         
        false                            //multiple         
        );

    this.declaredPropertyDefinitions[3] = new PropertyDefinitionImpl(
        "jcr:lastModified",              //name
        this,                            //declaringNodeType
        PropertyType.DATE,               //requiredType     
        EMPTY_CONSTRAINTS,               //valueConstraints 
        null,                            //defaultValues
        false,                           //autoCreate
        true,                            //mandatory        
        OnParentVersionAction.IGNORE,    //onVersion        
        false,                           //readOnly         
        false                            //multiple         
        );
  }
}
