/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: VersionLabelsType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class VersionLabelsType extends NodeTypeImpl {

  public VersionLabelsType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "nt:versionLabels";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredPropertyDefinitions = new PropertyDefinitionImpl[1];
    String[] constraints = {"nt:version"};

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        ItemDefinitionImpl.RESIDUAL_SET,    //name
        this,                   //declaringNodeType
        PropertyType.REFERENCE,      //requiredType     
        constraints,                 //valueConstraints
        null,                        //defaultValues    
        false,                       //autoCreate       
        false,                        //mandatory
        OnParentVersionAction.ABORT,  //onVersion
        true,                       //readOnly
        false                        //multiple         
        );

  }

}
