/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 31 juil. 2004
 */
public class VersionType extends NodeTypeImpl {

  public VersionType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "nt:version";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[2];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredSupertypes[1] = manager.getNodeType("mix:referenceable");
    this.declaredPropertyDefinitions = new PropertyDefinition[3];

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "jcr:created",                   //name
        this,                            //declaringNodeType
        PropertyType.DATE,               //requiredType     
        EMPTY_CONSTRAINTS,                            //valueConstraints
        null,                     //defaultValues
        true,                            //autoCreate       
        true,                            //mandatory        
        OnParentVersionAction.ABORT,     //onVersion        
        true,                            //readOnly         
        false                            //multiple         
        );

    String[] constraints = {"nt:version"};
    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "jcr:predecessors",              //name
        this,                           //declaringNodeType
        PropertyType.REFERENCE,          //requiredType     
        constraints,                     //valueConstraints 
        null,                     //defaultValues
        false,                           //autoCreate       
        false,                           //mandatory        
        OnParentVersionAction.ABORT,     //onVersion        
        true,                            //readOnly         
        true                             //multiple         
        );

    this.declaredPropertyDefinitions[2] = new PropertyDefinitionImpl(
        "jcr:successors",                //name
        this,                       //declaringNodeType
        PropertyType.REFERENCE,          //requiredType     
        constraints,                     //valueConstraints 
        null,                            //defaultValues    
        false,                           //autoCreate       
        false,                           //mandatory        
        OnParentVersionAction.ABORT,     //onVersion        
        true,                            //readOnly         
        true                             //multiple         
        );


    this.declaredChildNodeDefinitions = new NodeDefinition[1];
    NodeType[] types = {manager.getNodeType("nt:frozenNode")};
    this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
        "jcr:frozenNode",               // name
        this,                          // declaringNodeType
        types,                          // requiredNodeTypes
        null,                           // defaultNodeType
        false,                           // autoCreate
        false,                           // mandatory
        OnParentVersionAction.ABORT,    // onVersion        
        true,                           // protected        
        false                           // same-name sibling
        );
  }
}
