/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.PropertyDefinition;


import javax.jcr.version.OnParentVersionAction;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: VersionedChildType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class VersionedChildType extends NodeTypeImpl {

  public VersionedChildType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "nt:versionedChild";
    this.mixin = false;
    this.orderableChild = false;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredPropertyDefinitions = new PropertyDefinition[1];
    String[] constraints = new String[] {"nt:versionHistory"};
    
    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
            "jcr:childVersionHistory",       //name
            this,                            //declaringNodeType
            PropertyType.REFERENCE,          //requiredType     
            constraints,                     //valueConstraints
            null,                            //defaultValues
            true,                            //autoCreate       
            true,                            //mandatory        
            OnParentVersionAction.ABORT,     //onVersion        
            true,                            //readOnly         
            false                            //multiple         
            );
   
  }

}
