/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.storage;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.services.jcr.datamodel.InternalQPath;
import org.exoplatform.services.jcr.datamodel.MutablePropertyData;
import org.exoplatform.services.jcr.datamodel.NodeData;
import org.exoplatform.services.jcr.datamodel.ValueData;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: TransientPropertyData.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class TransientPropertyData extends TransientItemData implements
    MutablePropertyData {

  private List values;

  private int type;

  public TransientPropertyData(InternalQPath path, String uuid, int version,
      int type, String parentUUID) {
    super(path, uuid, version, parentUUID);
    this.type = type;
  }

  public List getValues() {
    return values;
  }

  public void setValues(List values) {
    this.values = values;
  }

  public void setValue(ValueData value) {
    this.values = new ArrayList();
    values.add(value);
  }

  public int getType() {
    return type;
  }

  public void setType(int type) {
    this.type = type;
  }

  public boolean isNode() {
    return false;
  }

}