/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.storage;

import java.io.UnsupportedEncodingException;
import java.util.Calendar;

import org.exoplatform.commons.utils.ISO8601;
import org.exoplatform.services.jcr.datamodel.InternalQName;
import org.exoplatform.services.jcr.datamodel.InternalQPath;
import org.exoplatform.services.jcr.datamodel.Uuid;
import org.exoplatform.services.jcr.datamodel.ValueData;
import org.exoplatform.services.jcr.impl.core.value.BaseValue;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: TransientValueData.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class TransientValueData implements ValueData {

  private byte[] data;

  private int orderNum = 0;

  public TransientValueData(byte[] value) {
    this.data = value;
  }

  public TransientValueData(String value) {
    try {
      this.data = value.getBytes(BaseValue.DEFAULT_ENCODING);
    } catch (UnsupportedEncodingException e) {
      throw new RuntimeException("FATAL ERROR Charset "
          + BaseValue.DEFAULT_ENCODING + " is not supported!");
    }
  }

  public TransientValueData(boolean value) {
    this.data = Boolean.valueOf(value).toString().getBytes();
  }

  public TransientValueData(Calendar value) {
    this.data = ISO8601.format(value).getBytes();
  }

  public TransientValueData(double value) {
    this.data = Double.valueOf(value).toString().getBytes();
  }

  public TransientValueData(long value) {
    this.data = Long.valueOf(value).toString().getBytes();
  }

  public TransientValueData(InternalQName value) {
    this.data = value.getAsString().getBytes();
  }

  public TransientValueData(InternalQPath value) {
    this.data = value.getAsString().getBytes();
  }

  public TransientValueData(Uuid value) {
    this.data = value.getString().getBytes();
  }

  public byte[] getAsByteArray() {
    return data;
  }

  public void setOrderNumber(int orderNum) {
    this.orderNum = orderNum;
  }

}