/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.jcr.impl.core.nodetype;


import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.Value;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.value.StringValue;

public class ExoType extends NodeTypeImpl {

  public ExoType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:exoType";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredPropertyDefinitions = new PropertyDefinition[1];

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "exo:name",               //name
        this,                       //declaringNodeType
        PropertyType.STRING,         //requiredType
        null,                        //valueConstraints 
        new Value[] {new StringValue("exoplatform")}, //defaultValues
        true,                       //autoCreate       
        true,                        //mandatory        
        OnParentVersionAction.COPY,  //onVersion        
        false,                       //readOnly         
        false
        );

  }
}
