/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.backup;

import java.util.zip.ZipOutputStream;

import org.apache.velocity.Template;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.templates.velocity.VelocityService ;
import org.exoplatform.services.database.XResources;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Apr 15, 2005
 * @version $Id$
 */
abstract public class DataTransformer {
  
  private String name ;
  private String description ;
  private String userDataTemplateName ; 
  private String serviceDataTemplateName ;
  private String userEntryExtension ;
  private String serviceEntryExtension ;
  private VelocityService tservice_ ;
  
  public DataTransformer() {
    
  }
  
  abstract public void init(ImportExportPlugin plugin) throws Exception  ;
  
  public String getName() { return name ; }
  public void   setName(String s) { name = s ;}
  
  public String getDescription() { return  description ; }
  public void   setDescription(String s) { description = s ; }
  
  public String getUserDataTemplateName() { return  userDataTemplateName ; }
  public void   setUserDataTemplateName(String s) { userDataTemplateName = s ; }
  
  public String getUserEntryExtension() { return  userEntryExtension ; }
  public void   setUserEntryExtension(String s) { userEntryExtension = s ; }
  
  public String getServiceDataTemplateName() { return  serviceDataTemplateName ; }
  public void   setServiceDataTemplateName(String s) { serviceDataTemplateName = s ; }
  
  public String getServiceEntryExtension() { return  serviceEntryExtension ; }
  public void   setServiceEntryExtension(String s) { serviceEntryExtension = s ; }
  
  public Template getUserTemplate() throws Exception {
    if(tservice_ == null) {
      tservice_ = (VelocityService)PortalContainer.getComponent(VelocityService.class) ;
    }
    return tservice_.getTemplate(userDataTemplateName) ;
  }
  
  public Template getServiceTemplate() throws Exception {
    if(tservice_ == null) {
      tservice_ = 
        (VelocityService)PortalContainer.getComponent(VelocityService.class) ;
    }
    return tservice_.getTemplate(serviceDataTemplateName) ;
  }
  
  
  abstract public void transformUserData(String user, ZipOutputStream os) throws Exception ;
  abstract public void transformServiceData( ZipOutputStream os) throws Exception ;
}
