/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.organization.impl;

import java.io.PrintWriter;
import java.util.Collection;
import java.util.Iterator;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.exoplatform.services.backup.DataTransformer;
import org.exoplatform.services.backup.ImportExportPlugin;
import org.exoplatform.services.organization.Group;
import org.exoplatform.services.organization.MembershipType;
import org.exoplatform.services.organization.OrganizationService;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Apr 16, 2005
 * @version $Id$
 */
public class DataTransformerImpl extends DataTransformer {
  private OrganizationService orgService_ ; 
  
  public void init(ImportExportPlugin plugin) throws Exception  {
    ImportExportPluginImpl impl = (ImportExportPluginImpl) plugin ;
    orgService_ = impl.orgService_ ;
  }
  
  public void transformUserData(String username, ZipOutputStream os) throws Exception {
    Template template = getUserTemplate() ;
    VelocityContext context = new VelocityContext() ;
    Object object = orgService_.getUserHandler().findUserByName(username) ;
    context.put("user", object) ;
    object = orgService_.getUserProfileHandler().findUserProfileByName(username) ;
    context.put("profile", object) ;
    object = orgService_.getMembershipHandler().findMembershipsByUser(username) ;
    context.put("memberships", object) ;
    os.putNextEntry(new ZipEntry("user" + getUserEntryExtension()));
    PrintWriter w = new PrintWriter(os);  
    template.merge(context, w) ;
    w.flush();
    os.closeEntry() ;
  }

  public void transformServiceData( ZipOutputStream os) throws Exception {   
    Template template = getServiceTemplate() ;
    PrintWriter w = new PrintWriter(os);
    
    Collection groups = orgService_.getGroupHandler().getAllGroups();      
//    System.out.println(" ta da co duoc o trong nay "+ groups.size());
//      session.find("from g in class org.exoplatform.services.organization.impl.GroupImpl") ;

    Iterator i = groups.iterator() ;
    VelocityContext context = new VelocityContext() ;
    while(i.hasNext()) {
      Group data = (Group) i.next() ;
      ZipEntry entry = new ZipEntry("group/" + data.getId()+ getServiceEntryExtension()) ;
//      System.out.println( "group/" + data.getId()+ getServiceEntryExtension());
      os.putNextEntry(entry) ;
      context.put("group", data) ;
      template.merge(context, w) ;
      w.flush() ;
      os.closeEntry() ;
    }
    Collection membershipTypes = orgService_.getMembershipTypeHandler().findMembershipTypes();    

    i = membershipTypes.iterator() ;
    context = new VelocityContext() ;
    while(i.hasNext()) {
      MembershipType data = (MembershipType) i.next() ;
      ZipEntry entry = new ZipEntry("membership-type/" +data.getName()+ getServiceEntryExtension()) ;
//      System.out.println( "membership-type/" +data.getName()+ getServiceEntryExtension());
      os.putNextEntry(entry) ;
      context.put("type", data) ;
      template.merge(context, w) ;
      w.flush() ;
      os.closeEntry() ;
    }   
  }
}
