/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.portal.component;

import java.util.Collection;
import java.util.ResourceBundle;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.portlet.ActionResponse;

import org.exoplatform.container.SessionContainer;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UIGrid;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.model.PageListDataHandler;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.CheckRoleInterceptor;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portal.filter.ExoRequestFilter;
import org.exoplatform.portal.session.RequestInfo;
import org.exoplatform.services.portal.PortalConfigService;
import org.exoplatform.services.portal.Query;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIListUser.java,v 1.18 2004/10/22 14:23:30 tuan08 Exp $
 */
public class UIAvailablePortal extends UIGrid {  
	static Parameter[] VIEW = { new Parameter(ACTION , "view") } ;
	static Parameter[] EDIT =   { new Parameter(ACTION , "edit")  } ;
  static Parameter[] ADMIN =   { new Parameter(ACTION , "admin")  } ;
	
	private UIPageListIterator uiPageIterator_ ;
	private PortalConfigService service_ ;
	public UIAvailablePortal(UISearchForm uiSearchForm,
                           PortalConfigService service) throws Exception {
		setId("UIAvailablePortal") ;	
    setRendererType("VelocityRenderer");
    service_ = service ;
		uiPageIterator_ = new UIPageListIterator(new PageListDataHandler()) ;
    getChildren().add(uiPageIterator_);
    getChildren().add(uiSearchForm);
		addActionListener(ViewActionListener.class, "view") ;
    addActionListener(AdminActionListener.class, "admin") ;
    refresh(new Query(null, null, null)) ;
	}
	
  public Collection getPageListDataHandler(){ 
    return uiPageIterator_.getPageListDataHandler().getDatas() ; 
  }
  public Parameter[] getAdminParams() { return ADMIN ; }
  public Parameter[] getViewParams() { return VIEW ; }
  public Parameter[] getEditParams() { return EDIT ; }
  
  public void refresh(Query q) throws Exception {
    uiPageIterator_.setPageList(service_.findAllPortalConfigDescriptions(q)) ;
  }
	
	static public class AdminActionListener extends ExoActionListener  {
    public AdminActionListener() {
      addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    
    public void execute(ExoActionEvent event) throws Exception {
      String owner = event.getParameter(OBJECTID) ;
      RequestInfo rinfo = (RequestInfo) SessionContainer.getComponent(RequestInfo.class);
      if(owner.equals(rinfo.getPortalOwner()))  {
         Information iprovider = findInformationProvider(event.getComponent()) ;
         ResourceBundle res = getApplicationResourceBundle() ;
         iprovider.addMessage(new ExoFacesMessage(res.getString("UIAvailablePortal.msg.current-user"))) ;
        return ;
      }
      String path = rinfo.getContextPath() + "/faces/admin/" + owner + 
                    "?" + ExoRequestFilter.ADMIN_RETURN_ACTION + "=" + ExoRequestFilter.ADMIN ; 
      ExternalContext eContext = FacesContext.getCurrentInstance().getExternalContext();
      ActionResponse response = (ActionResponse) eContext.getResponse();
      response.sendRedirect(path);
    }
  }
  
	static public class ViewActionListener extends ExoActionListener  {
    public ViewActionListener() {
      addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    
		public void execute(ExoActionEvent event) throws Exception {
		}
	}
}