/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.display.statik.component;

import java.util.ResourceBundle;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.InformationProvider;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.ContentUtil;
import org.exoplatform.portlets.content.display.model.ContentConfig;


/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentConfigForm.java,v 1.4 2004/08/17 13:07:02 tuan08 Exp $
 */
public class UIContentConfigForm extends UISimpleForm {
  
  private UIStringInput nameInput_ ;
  private UIStringInput titleInput_ ;
  private UIStringInput uriInput_ ;
  private UIStringInput encodingInput_ ;
  private ContentConfig config_ ;
  
  public UIContentConfigForm() {
    super("configForm", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;
    nameInput_ = new UIStringInput("name", "") ;
    add(nameInput_);
    titleInput_ = new UIStringInput("title", "") ;
    add(titleInput_);
    uriInput_ = new UIStringInput("uri", "") ;
    add(uriInput_);
    encodingInput_ = new UIStringInput("encoding", "") ;
    add(encodingInput_);
    
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }

  public void setModificationAllowed(boolean b) {
    if(b == false)
      uriInput_.setEditable(false);
  }  
  
  public void setContentConfig(ContentConfig config) {
    config_ = config ;
    if (config == null) {
      nameInput_.setText("") ;
      nameInput_.setEditable(true) ;
      titleInput_.setText("") ;
      uriInput_.setText("") ;
      encodingInput_.setText("") ;
    } else {
      nameInput_.setText(config.getName()) ;
      nameInput_.setEditable(false) ;
      titleInput_.setText(config.getTitle()) ;
      uriInput_.setText(config.getUri()) ;
      encodingInput_.setText(config.getEncoding()) ;
    }
  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIContentConfigForm uiForm = (UIContentConfigForm) event.getComponent() ;
      uiForm.setRenderedSibling(UIContentConfig.class) ;
    }
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIContentConfigForm uiForm = (UIContentConfigForm) event.getComponent() ;
      if(uiForm.config_ == null) {
        uiForm.config_ = new ContentConfig() ;
      }
      String name = uiForm.nameInput_.getValue() ;
      if(name == null || name.length() == 0) {
        Information iprovider = findInformationProvider(uiForm) ;
        ResourceBundle res = getApplicationResourceBundle() ;
        iprovider.addMessage(new ExoFacesMessage(res.getString("UIContentConfigForm.msg.name-is-null"))) ;
        return ;
      }
      uiForm.config_.setName(name);
      uiForm.config_.setTitle( uiForm.titleInput_.getValue());
      uiForm.config_.setUri( uiForm.uriInput_.getValue());
      String encoding = uiForm.encodingInput_.getValue();
      if(encoding == null || "".equals(encoding)){
        encoding = "UTF-8";
      }
      uiForm.config_.setEncoding(encoding);
      UIContentConfig uiConfig = (UIContentConfig)uiForm.getSibling(UIContentConfig.class) ;
      uiConfig.saveContentConfig(ContentUtil.EDIT_STATE, uiForm.config_) ;
      uiForm.setRenderedSibling(UIContentConfig.class) ;
    }
  }

}