/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL. All rights reserved.         *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.display.statik.component;

import java.util.Enumeration;
import java.util.List;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletRequest;

import org.exoplatform.faces.core.component.UIPortlet;
import org.exoplatform.portlets.content.display.model.ContentConfig;

/**
 * @author benjaminmestrallet
 */
public class UIContentPortlet extends UIPortlet {

  final static public String[] DEFAULT_VALUES = { "title=", "uri=", "encoding=" };

  public UIContentPortlet() throws Exception {
    setClazz("UIContentPortlet");
    setRendererType("PyramidTabBarRenderer");
    ExternalContext eContext = FacesContext.getCurrentInstance()
        .getExternalContext();
    PortletRequest request = (PortletRequest) eContext.getRequest();
    PortletPreferences prefs = request.getPreferences();
    Enumeration e = prefs.getNames();
    List children = getChildren();
    boolean select = true;
    while (e.hasMoreElements()) {
      String name = (String) e.nextElement();
      String[] values = prefs.getValues(name, DEFAULT_VALUES);
      ContentConfig contentConfig = new ContentConfig(name, values);
      UIContentTab uiContentTab = new UIContentTab(contentConfig);
      uiContentTab.setId("id" + Integer.toString(uiContentTab.hashCode()));
      uiContentTab.setRendered(select);
      children.add(uiContentTab);
      select = false;
    }
  }

}