/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.portal.impl;

import org.exoplatform.services.cache.CacheService;
import org.exoplatform.services.cache.ExoCache;
import org.exoplatform.services.organization.Membership;
import org.exoplatform.services.organization.MembershipEventListener;
/**
 * Author : Tuan Nguyen
 *          tuan08@ms.sourceforge.net
 * Wed, Feb 18, 2004 @ 21:33 
 */
public class PortalMembershipEventListener extends MembershipEventListener {
  
  private ExoCache nodeNavigationCache_ ;

  public PortalMembershipEventListener(CacheService cacheService) throws Exception {
    nodeNavigationCache_ = cacheService.getCacheInstance(NodeImpl.class.getName()) ;
  }
  
  public void postDelete(Membership m) throws Exception {
    //invalidate the cache of membership owner.
    nodeNavigationCache_.remove(m.getUserName()) ;
  }
}
