/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm;

import condition.* ;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class ECMFileExplorerSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet Admin page and test all the basic actions" ;
  static String NAME = "EcmPortletAdminSuite" ;
  
  public ECMFileExplorerSuite() {    
    super(NAME, DESC) ;
    goToPage("/Home/ecm") ;
    addWebUnit(
      new ClickURLLinkUnit("SelectECMFileExplorer", "Select ECM File Explorer tab").
      setURL("componentId=ECMPage&portal:action=changeTab&objectId=jcr").                  
      addValidator(new ExpectTextValidator("Workspaces"))      
    ) ;        
    //Action
    addWebUnit(
      new ClickURLLinkUnit("ClickOnProduction", "click on Production button").
      setURL("&uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=production").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectWorkspace"))      
    ) ;            
    //-----Delete if test-folder is existed
    addWebUnit(
      new ClickURLLinkUnit("DeleteExistedFolder", "Delete if test-folder is existed").
      setURL("&uicomponent=UIDocumentInfo&op=removeNode&objectId=test-folder").
      addCondition(new HaveLinkWithURLCondition("&uicomponent=UIDocumentInfo&op=removeNode&objectId=test-folder")).
      addValidator(new ExpectTextValidator("The node /test-folder has been removed."))
    ) ;  
    //-----Add Folder
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddFolder", "click on Add Folder button").
      setURL("&uicomponent=UIToolbar&op=addFolder").                  
      addValidator(new ExpectFormIdValidator("folderForm"))      
    ) ;       
    //----------Save New Folder
    addWebUnit(
      new SubmitFormUnit("SaveNewFolder", "click on Save button").
      setFormId("folderForm").   
      setField("name","test-folder").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/test-folder"))      
    ) ;    
    /*    
    //---------------Lock Created Folder
    addWebUnit(
      new ClickURLLinkUnit("LockCreatedFolder", "click on Lock button").
      setURL("&uicomponent=UIDocumentInfo&op=lock&objectId=test-folder").   
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=unlock&objectId=cms"))
    ) ;    
    */    
    //-----Select test-folder
    addWebUnit(
      new ClickURLLinkUnit("ClickOnCreatedFolder", "click on test-folder").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/test-folder").                  
      addValidator(new ExpectTextValidator(">")).
      addValidator(new ExpectTextValidator("test-folder"))
    ) ;    
    //-----Add Document to created Folder
    addWebUnit(
      new ClickURLLinkUnit("AddDocumentToCreatedFolder", "click on Add Document button").
      setURL("&uicomponent=UIToolbar&op=addDocument").                  
      addValidator(new ExpectFormIdValidator("selectDocumentForm")).
      addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;     
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("documentForm").   
      setField("docName","doc-name").
      setField("summary","content").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=editDocument&objectId=doc-name"))
    ) ;    
    //-----Search
    addWebUnit(
      new ClickURLLinkUnit("BackToHome", "click on home button").
      setURL("&uicomponent=UIJCRExplorer&op=changeNode&objectId=/").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/cms"))      
    ) ;    
    //----------Simple Search
    addWebUnit(
      new ClickURLLinkUnit("SimpleSearch", "click on Search button").
      setURL("&uicomponent=UIToolbar&op=search").           
      addValidator(new ExpectFormIdValidator("UISimpleSearch"))      
    ) ;    
    addWebUnit(
      new SubmitFormUnit("SimpleSearchAction", "click on Searchlink").
      setFormId("UISimpleSearch").
      setField("text","cms").
      setField("op","searchAction").                        
      addValidator(new ExpectTextValidator("Search Results (")).
      addValidator(new ExpectTextValidator("cms"))
    ) ;
    /*
    //----------New Query
    addWebUnit(
      new ClickURLLinkUnit("AdvancedSearch", "click on New Query button").
      setURL("&uicomponent=UISearch&op=selectNode&objectId=UIJCRAdvancedSearch").   
      addValidator(new ExpectFormIdValidator("UIJCRAdvancedSearch"))      
    ) ;    
    addWebUnit(
      new SubmitFormUnit("SaveAdvancedSearch", "click on Save link").
      setFormId("UIJCRAdvancedSearch").      
      setField("name","Advanced-Search-name").
      setField("select","sql").
      setField("query","select * from nt:base").
      setField("op","save").                        
      addValidator(new ExpectTextValidator("UIJCRAdvancedSearch.msg.query-added"))      
    ) ;
    addWebUnit(
      new SubmitFormUnit("AdvancedSearchAction", "click on Search link").
      setFormId("UIJCRAdvancedSearch").            
      setField("select","sql").
      setField("query","select * from nt:base").
      setField("op","searchAction").                        
      addValidator(new ExpectTextValidator("Search Results ("))      
    ) ;
    //----------Saved Queries
    addWebUnit(
      new ClickURLLinkUnit("ClickOnSavedQuries", "click on New Query button").
      setURL("&uicomponent=UISearch&op=selectNode&objectId=UIQueryList").        
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIQueryList&op=delete&objectId=/cms/home/users/admin/queries/Advanced-Search-name"))      
    ) ;
    */   
    //-----Select test-folder    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnBack", "click on back button").      
      setURL("&uicomponent=MainToolbar&op=back")      
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnCreatedFolder", "click on test-folder").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/test-folder").                  
      addValidator(new ExpectTextValidator(">")).
      addValidator(new ExpectTextValidator("test-folder"))
    ) ;  
    //Info
    //-----Select Info tab
    addWebUnit(
      new ClickURLLinkUnit("SelectInfoTab", "click on info tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIInfoAction").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewReferences")).         
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewNodeType")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewPermissions")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewProperties"))
    ) ;
    //-----View Preferences
    addWebUnit(
      new ClickURLLinkUnit("ClickOnViewPreferences", "click on View Preferences button").
      setURL("&uicomponent=UIToolbar&op=viewReferences").          
      addValidator(new ExpectTextValidator("Workspace"))      
    ) ;
    //-----View Node Type
    addWebUnit(
      new ClickURLLinkUnit("ClickOnViewNodeType", "click on View Node Type button").
      setURL("&uicomponent=UIToolbar&op=viewNodeType").        
      addValidator(new ExpectTextValidator("Node Property"))      
    ) ;    
    //-----View Permisions
    addWebUnit(
      new ClickURLLinkUnit("ClickOnViewPermisions", "click on View Permisions button").
      setURL("&uicomponent=UIToolbar&op=viewPermissions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPermissionsInfo&op=addPermission"))      
    ) ;         
    //----------Add Permisions
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddPermisions", "click on Add Permisions button").
      setURL("&uicomponent=UIPermissionsInfo&op=addPermission").                  
      addValidator(new ExpectFormIdValidator("permissionForm"))      
    ) ;    
    //---------------Search Group
    addWebUnit(
      new SubmitFormUnit("SearchGroup", "click on search button").
      setFormId("permissionForm").   
      setField("op","searchGroup").               
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIExoPermissionBrowser&op=selectGroup&objectId=/admin"))      
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("SelectGroup", "select a group").
      setURL("&uicomponent=UIExoPermissionBrowser&op=selectGroup&objectId=/admin").              
      addValidator(new ExpectFormIdValidator("permissionForm"))      
    ) ;         
    /*
    //---------------Save Permisions
    addWebUnit(
      new SubmitFormUnit("SavePermission", "click on save button").
      setFormId("permissionForm").   
      setField("userOrGroup","*:/admin").
      setCheckBox("read",true).
      setCheckBox("add_node",true).
      setCheckBox("set_property",true).
      setCheckBox("remove",true).
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPermissionsInfo&op=removePermission&objectId=*:/admin"))
    ) ;
    */
    //-----View Node Properties (test-folder's properties)
    addWebUnit(
      new ClickURLLinkUnit("ClickOnNodeProperties", "click on View Node Properties button").
      setURL("&uicomponent=UIToolbar&op=viewProperties").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPropertiesInfo&op=addProperty"))
    ) ;             
    //----------Add Property
    addWebUnit(
      new ClickURLLinkUnit("AddProperty", "click on Add Property button").
      setURL("&uicomponent=UIPropertiesInfo&op=addProperty").                  
      addValidator(new ExpectFormIdValidator("propertyForm"))      
    ) ;     
    /*
    //---------------Save Property
    addWebUnit(
      new SubmitFormUnit("SaveProperty", "click on save button").
      setFormId("propertyForm").
      setField("name","property-test").                        
      setField("value","value-test").
      setField("op","save").
      addValidator(new ExpectTextValidator("UIPropertyForm.msg.unsetable"))
    ) ;
    */    
    //Admin    
    //-----Select Admin tab
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTab", "click on Admin tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIAdminAction").             
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageVersions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageCategories")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageActions")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=upload")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=exportNode")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=importNode"))
    ) ;
    //-----Manage Versions (test-folder's version)
    addWebUnit(
      new ClickURLLinkUnit("ClickOnManageVersions", "click on Manage Versions button").
      setURL("&uicomponent=UIToolbar&op=manageVersions").           
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIVersionInfo&op=enableVersion"))      
    ) ;         
    //----------Enable Versioning
    addWebUnit(
      new ClickURLLinkUnit("ClickOnEnableVersioning", "select Enable Versioning link").
      setURL("&uicomponent=UIVersionInfo&op=enableVersion").                  
      addValidator(new ExpectTextValidator("You need to save the node to be able to access the version tree."))      
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("SaveSession", "Click on save session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").       
      addValidator(new ExpectTextValidator("jcr:rootVersion"))      
    ) ;   
    //-----Manage Category
    addWebUnit(
      new ClickURLLinkUnit("ClickOnManageCategory", "click on Manage Category button").
      setURL("&uicomponent=UIToolbar&op=manageCategories").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=add"))      
    ) ;   
    //----------Add Category
    addWebUnit(
      new ClickURLLinkUnit("AddCategory", "click on Add Category button").
      setURL("&uicomponent=UICategoriesList&op=add").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms/categories/cms/news"))      
    ) ;     
    addWebUnit(
      new ClickURLLinkUnit("SelectNode", "click select button on node row").
      setURL("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms/categories/cms/news").      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=delete&objectId=/cms/categories/cms/news"))      
    ) ;
    //-----Manage Actions
    addWebUnit(
      new ClickURLLinkUnit("ClickOnManageActions", "click on Manage Actions button").
      setURL("&uicomponent=UIToolbar&op=manageActions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIActionList&op=add"))      
    ) ;   
    //----------Add/Edit Actions
    addWebUnit(
      new ClickURLLinkUnit("AddAction", "click on add button").
      setURL("&uicomponent=UIActionList&op=add").   
      addValidator(new ExpectFormIdValidator("selectActionForm")).
      addValidator(new ExpectFormIdValidator("workflowForm"))            
    ) ;
    addWebUnit(
      new SubmitFormUnit("SelectActionOfType", "select action of type is exo:workflowAction").
      setFormId("selectActionForm").
      setField("actionType","exo:workflowAction").
      setField("op","change").  
      addValidator(new ExpectTextValidator("ContentValidation"))      
    ) ;
    //---------------Search Validator
    addWebUnit(
      new SubmitFormUnit("SearchValidator:", "click on search button").
      setFormId("workflowForm").   
      setField("op","selectValidator").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIExoPermissionBrowser&op=selectGroup&objectId=/admin"))      
    ) ;        
    addWebUnit(
      new ClickURLLinkUnit("SelectGroup", "select a group").
      setURL("&uicomponent=UIExoPermissionBrowser&op=selectGroup&objectId=/admin").                  
      addValidator(new ExpectFormIdValidator("workflowForm"))      
    ) ;      
    //----------Save Action
    addWebUnit(
      new SubmitFormUnit("SaveNewAction", "select action of type, fill all informations and click save button").
      setFormId("workflowForm"). 
      setField("name","name-test").
      setField("lifecycle","read").      
      setField("description","description-test").
      setField("validator","*:/admin").
      setField("destWorkspace","production").                
      setField("destPath","/jcr:system").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIActionList&op=view&objectId=name-test"))
    ) ;        
    //-----Upload a file to created Folder
    addWebUnit(
      new ClickURLLinkUnit("UploadFileToFolder", "click on Upload button").
      setURL("&uicomponent=UIToolbar&op=upload").                  
      addValidator(new ExpectFormIdValidator("uploadForm"))      
    ) ;         
    //----------Save File
    def is = Thread.currentThread().
        getContextClassLoader().
        getResourceAsStream("org/exoplatform/test/web/Util.class") ;    
    addWebUnit(
      new SubmitFormUnit("SaveFile", "click on save button").
      setFormId("uploadForm").   
      setFileField("upload","Unit.class", is).
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/test-folder/upload"))      
    ) ;        
    addWebUnit(
      new ClickURLLinkUnit("SaveSession", "Persist the data to the database").
      setURL("uicomponent=MainToolbar&op=saveSession"). 
      addValidator(new ExpectTextValidator("All the changes have been saved"))
    ) ;
    //-----Export Node
    addWebUnit(
      new ClickURLLinkUnit("ClickOnExportNode", "click on Export Node button").
      setURL("&uicomponent=UIToolbar&op=exportNode").           
      addValidator(new ExpectTextValidator("Path To Export:"))      
    ) ; 
    //-----Import Node
    addWebUnit(
      new ClickURLLinkUnit("ClickOnImportNode", "click on Import Node button").
      setURL("&uicomponent=UIToolbar&op=importNode").                  
      addValidator(new ExpectFormIdValidator("importForm"))      
    ) ;                     
    /*
    //Action
    addWebUnit(
      new ClickURLLinkUnit("ClickOnActionTab", "click on action tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIDefaultAction")
    ) ;
    //-----Copy Created Folder
    addWebUnit(
      new ClickURLLinkUnit("CopyCreatedFolder", "click on copy button").
      setURL("&uicomponent=UIDocumentInfo&op=copy&objectId=test-folder").         
      addValidator(new ExpectTextValidator("The node /test-folder has been copied."))          
    ) ;    
    //-----Cut Created Folder
    addWebUnit(
      new ClickURLLinkUnit("CutCreatedFolder", "click on cut button").
      setURL("&uicomponent=UIDocumentInfo&op=cut&objectId=test-folder").               
      addValidator(new ExpectTextValidator("The node /test-folder has been cut."))      
    ) ;
    //-----Save change for Created Folder
    addWebUnit(
      new ClickURLLinkUnit("SaveNewFolder", "click on Save button").      
      setURL("&uicomponent=UIDocumentInfo&op=saveNode&objectId=test-folder").               
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    //Saved Session
    addWebUnit(
      new ClickURLLinkUnit("ClickOnSavedQuries", "click on New Query button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("UIJCRExplorer.msg.save-session-success"))      
    ) ;
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;
    */
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite("admin", "exo", roles)] ;
  }  
}